package riomhaire.lti.infrastructure.api.tool;


import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.ModelAndView;
import riomhaire.lti.business.actions.ProcessOidcRequest;
import riomhaire.lti.infrastructure.Registry;

import java.util.HashMap;
import java.util.Map;

@RestController
@Slf4j
public class OIDCEndpoint {

    @Autowired
    Registry registry;

    @RequestMapping(path = "/oidc")
    public ModelAndView oidc(@RequestParam Map<String, String> queryParams, @RequestHeader HashMap<String, Object> headers) {

        return ProcessOidcRequest.builder()
                .registry(registry)
                .queryParams(queryParams)
                .metadata(headers)
                .build()
                .execute();
    }


}
